%
% This function computes the matrix that performs the cross product
% operation so that instead of axb we have Ab.
%
% @param a The left hand operand of the cross product.
%
% @return A The 3x3 skew symmetric matrix that produces the equivalent
%           effect as performing the cross product operation with the given 
%           vector as the left operand.
%         
% @author Stefan Wiesner (stefan_wiesner@freenet.de)
%
function A = crossMatrix(a)

A = [0     -a(3)   a(2) ;
     a(3)     0   -a(1) ;
    -a(2)   a(1)     0 ];
