function varargout = sphericalFiducialLocalization3D(varargin)
% SPHERICALFIDUCIALLOCALIZATION3D M-file for sphericalFiducialLocalization3D.fig
%      SPHERICALFIDUCIALLOCALIZATION3D, by itself, creates a new SPHERICALFIDUCIALLOCALIZATION3D or raises the existing
%      singleton*.
%
%      H = SPHERICALFIDUCIALLOCALIZATION3D returns the handle to a new SPHERICALFIDUCIALLOCALIZATION3D or the handle to
%      the existing singleton*.
%
%      SPHERICALFIDUCIALLOCALIZATION3D('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in SPHERICALFIDUCIALLOCALIZATION3D.M with the given input arguments.
%
%      SPHERICALFIDUCIALLOCALIZATION3D('Property','Value',...) creates a new SPHERICALFIDUCIALLOCALIZATION3D or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before sphericalFiducialLocalization3D_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property
%      application
%      stop.  All inputs are passed to sphericalFiducialLocalization3D_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help sphericalFiducialLocalization3D

% Last Modified by GUIDE v2.5 01-Apr-2010 15:09:39

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @sphericalFiducialLocalization3D_OpeningFcn, ...
                   'gui_OutputFcn',  @sphericalFiducialLocalization3D_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before sphericalFiducialLocalization3D is made visible.
function sphericalFiducialLocalization3D_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to sphericalFiducialLocalization3D (see VARARGIN)

    %choose default command line output for fiducialLocalization
  handles.output = hObject;

  
      %set the figure's colormap (each figure has its own) to gray scale
      %for viewing X-ray images 
  colormap(gray(256));
                                      
         %parameters are already saved, this is an initialization value
  handles.fiducialParametersSaved = 1;

          %set DEFAULT parameter values
          
      %edge based localization, parameters used by the Canny edge detector 
      %and the RANSAC framework
  handles.EdgeBasedLocalization.cannyStd = 1.0;
  handles.EdgeBasedLocalization.cannyLowThreshold = 0.3;
  handles.EdgeBasedLocalization.cannyHighThreshold = 0.7;
  handles.EdgeBasedLocalization.expectedRadiusRange = [2.8,3.3];        
  handles.EdgeBasedLocalization.agreementTolerance = 1.0;
  
  handles.IntensityBasedLocalization.connectivity = 18;
         %parameters used for display (see displayData function for the exact
         %usage) 
  handles.Display.sphereRadius = 3.0;
  handles.Display.roiLineStyle = ':';
  handles.Display.roiLineColor = [1.0, 0.0, 0.0];
  handles.Display.fiducialColorTable = {[1, 0, 0],...
                                        [0, 1, 0],...
                                        [0, 0, 1],...
                                        [1, 1, 0],...
                                        [0, 1, 1],...
                                        [1, 0, 1],...
                                        [0, 0, 0],...
                                        [1, 1, 1]};
  handles.Display.fiducialLineWidth = 1;
  handles.Display.fiducialLineStyle = '-';
  handles.Display.aboveThresholdOverlayColor = [1.0, 0.0, 0.0];
    
                  %struct containing two cell arrays of equal length:
                  %pixelData - the actual images
                  %dcmInfo - the DICOM information associated with each
                  %          image
  handles.images = struct('pixelData',cell(0),'dcmInfo',cell(0));
  handles.fileNames = cell(0);
          %index of currently displayed image
  handles.currentDisplayImageNumber = -1;
           %a cell array containing cell arrays with the spherical fiducial
           %parameters [x;y;z;r]
  handles.allFiducialParameters = cell(0);
       
  handles.zoomOn = 0;
  handles.panOn = 0;
  
        %the ROI box is defined by the images and the 2D bounds in the XY
        %plane
  handles.currentROIImageIndexes = [];
  handles.currentROIXYBounds = [];
  
          %voxel values above this threshold are part of the fiducial
  handles.threshold = intmax('uint16');  
                            %create the threshold selection dialog (it's 'Visible'
                            %property is by default off)
  handles.thresholdSelectionDialog = thresholdSelectionDialog(handles.figure1, @displayData, @intensityWeightedCentroidFiducialLocalization);

  %set the function that is called when the GUI is closed. if the 
          %data wasn't saved it quries the user wether to exit or not
  set(handles.figure1,'CloseRequestFcn',@closeGUI);
  
       %user supplied settings will override default values set above
  if size(varargin,2)==2 && isa(varargin{2}, 'char') && exist(varargin{2},'file')
    loadProgramSettings(varargin{2}, handles, hObject);
  else
    if size(varargin,2)==2 && (~isa(varargin{2}, 'char') || ~exist(varargin{2},'file'))
      warndlg('Second parameter is not a valid file name. Using default settings.',...
               'Invalid Settings');
    end
         %update handles structure, if there were user supplied values the
         %'loadProgramSettings' updated the handles structure
    guidata(hObject, handles);
  end

% --------------------------------------------------------------------
%
% Load user supplied program settings specified in an xml file.
% Read the xml file using matlab's DOM based approach and then get the
% values using the expected tree structure. If the user does not comply
% with the expected tree structure or does not specify all parameters we
% issue a warnning and use the default values.
%
function loadProgramSettings(settingsFileName, handles, hObject)
 
try
  warnningMessages = cell(0);
  validLineStyles = {'-','--',':','-.'};
    
    
  document = xmlread(settingsFileName);
  
                %load settings for edge based localization                
  cannyStd = getNumericValue(document,... 
                            {'FiducialLocalizationSettings', 'EdgeBasedLocalization', 'CannyEdgeDetector', 'Std'});
  if ~isempty(cannyStd) && cannyStd>0
    handles.EdgeBasedLocalization.cannyStd = cannyStd;
  else
    warnningMessages{end+1} = 'Std tag for Canny edge detector missing or invalid value.'; 
  end
  
  cannyLowThreshold = getNumericValue(document,... 
                            {'FiducialLocalizationSettings', 'EdgeBasedLocalization', 'CannyEdgeDetector', 'LowThreshold'});
  cannyHighThreshold = getNumericValue(document,... 
                            {'FiducialLocalizationSettings', 'EdgeBasedLocalization', 'CannyEdgeDetector', 'HighThreshold'});
  if ~isempty(cannyLowThreshold) && ~isempty(cannyHighThreshold) &&...
      cannyLowThreshold<cannyHighThreshold
    handles.EdgeBasedLocalization.cannyLowThreshold = cannyLowThreshold;
    handles.EdgeBasedLocalization.cannyHighThreshold = cannyHighThreshold;
  else
    warnningMessages{end+1} = 'LowThreshold or HighThreshold tags for Canny edge detector missing or invalid values.'; 
  end
  
  minimalExpectedRadiusRange = getNumericValue(document,... 
                                              {'FiducialLocalizationSettings', 'EdgeBasedLocalization', 'SphereRANSAC', 'MinimalExpectedRadius'});
  maximalExpectedRadiusRange = getNumericValue(document,... 
                                              {'FiducialLocalizationSettings', 'EdgeBasedLocalization', 'SphereRANSAC', 'MaximalExpectedRadius'});
  if ~isempty(minimalExpectedRadiusRange) &&  ~isempty(maximalExpectedRadiusRange) &&...
    minimalExpectedRadiusRange<maximalExpectedRadiusRange
    handles.EdgeBasedLocalization.expectedRadiusRange = [minimalExpectedRadiusRange, maximalExpectedRadiusRange];
  else
    warnningMessages{end+1} = 'MinimalExpectedRadius or MaximalExpectedRadius tags for RANSAC sphere estimator missing or invalid values.';
  end
  
  agreementTolerance = getNumericValue(document,... 
                                      {'FiducialLocalizationSettings', 'EdgeBasedLocalization', 'SphereRANSAC', 'AgreementTolerance'});
  if ~isempty(agreementTolerance) && agreementTolerance>0
    handles.EdgeBasedLocalization.agreementTolerance = agreementTolerance;
  else
    warnningMessages{end+1} = 'AgreementTolerance tag for RANSAC sphere estimator missing or invalid value.';
  end
  
                %load settings for intensity based localization                
  connectivity = getNumericValue(document,... 
                                {'FiducialLocalizationSettings', 'IntensityBasedLocalization', 'Connectivity'});
  if ~isempty(find(connectivity==[6, 18, 26]))
    handles.IntensityBasedLocalization.connectivity = connectivity;
  else
    warnningMessages{end+1} = 'Connectivity tag for intensity based localization missing or invalid value.';
  end
                  %load settings for display
  sphereRadius = getNumericValue(document,... 
                                {'FiducialLocalizationSettings', 'Display', 'SphereRadius'});                
  if ~isempty(sphereRadius) && sphereRadius>0
    handles.Display.sphereRadius = sphereRadius;
  else
    warnningMessages{end+1} = 'SphereRadius tag for display missing or invalid value.';
  end
  
  roiLineStyle = getStringValue(document,... 
                                {'FiducialLocalizationSettings', 'Display', 'ROILineStyle'});
  if ~isempty(roiLineStyle) && find(strcmp(roiLineStyle, validLineStyles)==1)
    handles.Display.roiLineStyle = roiLineStyle;
  else
    warnningMessages{end+1} = 'Display ROILineStyle tag missing or invalid value.';
  end
  
  roiLineColor = getNumericValue(document,...
                                {'FiducialLocalizationSettings', 'Display', 'ROILineColor'});
  if ~isempty(roiLineColor) && all(roiLineColor<=1.0) && all(roiLineColor>=0.0)
    handles.Display.roiLineColor = roiLineColor;
  else
    warnningMessages{end+1} = 'Display ROILineColor tag missing or invalid value.';
  end
    
  fiducialColorTable = getMultipleNumericValues(document,...
                                                 {'FiducialLocalizationSettings', 'Display', 'FiducialColorTable', 'FiducialColor'});
  if ~isempty(fiducialColorTable) && all(cell2mat(fiducialColorTable)<=1.0) && all(cell2mat(fiducialColorTable)>=0.0)
    handles.Display.fiducialColorTable = fiducialColorTable;
  else
    warnningMessages{end+1} = 'Display FiducialColorTable/FiducialColor tags missing or invalid value.';
  end
  
  fiducialLineWidth = getNumericValue(document,...
                                      {'FiducialLocalizationSettings', 'Display', 'FiducialLineWidth'});
  if ~isempty(fiducialLineWidth) && fiducialLineWidth>0                                  
    handles.Display.fiducialLineWidth = fiducialLineWidth;
  else
    warnningMessages{end+1} = 'Display FiducialLineWidth tag missing or invalid value.';
  end
  
  fiducialLineStyle = getStringValue(document,... 
                                     {'FiducialLocalizationSettings', 'Display', 'FiducialLineStyle'});
  if ~isempty(fiducialLineStyle) && find(strcmp(fiducialLineStyle, validLineStyles)==1)
    handles.Display.fiducialLineStyle = fiducialLineStyle;
  else
    warnningMessages{end+1} = 'Display FiducialLineStyle tag missing or invalid value.';
  end
  
  aboveThresholdOverlayColor  = getNumericValue(document,...
                                                {'FiducialLocalizationSettings', 'Display', 'AboveThresholdOverlayColor'});
  if ~isempty(aboveThresholdOverlayColor) && all(aboveThresholdOverlayColor<=1.0) && all(aboveThresholdOverlayColor>=0.0)
    handles.Display.aboveThresholdOverlayColor = aboveThresholdOverlayColor;
  else
    warnningMessages{end+1} = 'Display AboveThresholdOverlayColor tag missing or invalid value.';
  end

  if ~isempty(warnningMessages)
    warndlg(warnningMessages, 'Loading Settings Warnning');
  end
catch
   errordlg(sprintf('Failed reading XML file %s', settingsFileName),...
            'Invalid Input', 'modal');
   guidata(hObject, handles);       
   return;
end

         %update handles structure
  guidata(hObject, handles);
% --------------------------------------------------------------------    

function values = getMultipleNumericValues(parent, tagNames)
  values = cell(0);
  
  n = size(tagNames, 2);
  for i=1:n-1    
    childNodeList = parent.getElementsByTagName(tagNames(i));
    if childNodeList.getLength~=1
      return;
    end  
    parent = childNodeList(1).item(0);
  end
  nodeList = parent.getElementsByTagName(tagNames(end));
  n = nodeList.getLength;
  for i=1:n
    values{i} = str2num(char(nodeList.item(i-1).getFirstChild.getData));
  end
  
% --------------------------------------------------------------------

function value = getNumericValue(parent, tagNames)
  value = [];
  
  n = size(tagNames, 2);
  for i=1:n    
    childNodeList = parent.getElementsByTagName(tagNames(i));
    if childNodeList.getLength~=1
      return;
    end  
    parent = childNodeList(1).item(0);
  end
  value = [str2num(char(parent.getFirstChild.getData))];
  
% --------------------------------------------------------------------    

function value = getStringValue(parent, tagNames)
  value = [];
  
  n = size(tagNames, 2);
  for i=1:n    
    childNodeList = parent.getElementsByTagName(tagNames(i));
    if childNodeList.getLength~=1
      return;
    end  
    parent = childNodeList(1).item(0);
  end
  value = strtrim(char(parent.getFirstChild.getData));
% --------------------------------------------------------------------    
% --- Outputs from this function are returned to the command line.
function varargout = sphericalFiducialLocalization3D_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% --------------------------------------------------------------------

% --- Executes on selection change in fileNamesListbox.
function fileNamesListbox_Callback(hObject, eventdata, handles)
% hObject    handle to fileNamesListbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns fileNamesListbox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from fileNamesListbox

% --------------------------------------------------------------------

% --- Executes during object creation, after setting all properties.
function fileNamesListbox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to fileNamesListbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --------------------------------------------------------------------

% --- Executes on slider movement.
function imageSlider_Callback(hObject, eventdata, handles)
% hObject    handle to imageSlider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

          %get the new slice number
  sliderValue = round(get(hObject,'Value'));
  handles.currentDisplayImageNumber = size(handles.images,2) + 1 - sliderValue;
           %update the list box, change the color of the currently displayed file to
           %red and scroll the listbox so that this selection is at the top
           %(synchronizing the listbox and slider).
  fileNames = handles.fileNames;
  fileNames{handles.currentDisplayImageNumber} = sprintf('<html><font color="red">%s</font></html>',...
                                                         fileNames{handles.currentDisplayImageNumber});    
  set(handles.fileNamesListbox, 'String', fileNames, 'listboxtop', handles.currentDisplayImageNumber);
       %save the data and display
  guidata(gcbo, handles);     
  displayData(guidata(gcbo));

% --------------------------------------------------------------------

% --- Executes during object creation, after setting all properties.
function imageSlider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to imageSlider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

% --------------------------------------------------------------------
function resetButton_Callback(hObject, eventdata, handles)
  zoom(handles.figure1,'off');
  zoom(handles.figure1, 'out');
  handles.zoomOn = 0;    
  pan(handles.figure1,'off');
  handles.panOn = 0;
  set(handles.imageAxes,'CLim', [handles.minIntensity, handles.maxIntensity]);
  guidata(hObject, handles);

% --------------------------------------------------------------------

% --- Executes on button press in zoomToolButton.
function zoomToolButton_Callback(hObject, eventdata, handles)
  if handles.zoomOn
    zoom(handles.figure1,'off');
    handles.zoomOn = 0;    
  else
    zoom(handles.figure1,'on');
    handles.zoomOn = 1;    
  end
  guidata(hObject, handles);

% --------------------------------------------------------------------
function panToolButton_Callback(hObject, eventdata, handles)
  if handles.panOn
    pan(handles.figure1,'off');
    handles.panOn = 0;    
  else
    pan(handles.figure1,'on');
    handles.panOn = 1;    
  end
  guidata(hObject, handles);
  
% --------------------------------------------------------------------
function windowLevelButton_Callback(hObject, eventdata, handles)
  imcontrast(handles.imageAxes);

% --------------------------------------------------------------------
function fileMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to fileMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function loadDicomImages_Callback(hObject, eventdata, handles)

                %open the file dialog and choose the DICOM files
  fileFilterSpecification = {'*.dcm;*.ima','DICOM files (*.dcm, *.ima)';...
                             '*.*','All files (*.*)'};
  fileDialogTitle = 'Load DICOM files';  
  [fileNames, pathName] = uigetfile(fileFilterSpecification,...
                                   fileDialogTitle,...
                                   'MultiSelect','on');
                                 
         %user canceled the file selection
  if isequal(fileNames, 0)
    return;
  end
       %if the user only selects one file the returned value is a string
       %and not a cell array of strings. In our case all data sets must consist  
       %of more than one image, which is enforced here.
  if ~iscell(fileNames)
    errordlg('Only one file selected. Volume must include more than one file.',...
             'Invalid Input', 'modal');
    return;
  end
            %switch to the hourglass pointer and force a redraw 
  set(handles.figure1,'Pointer','watch');
  drawnow();            
  i=1;
           %read first image's DICOM info and ensure that all images come 
           %from this study/series
  try         
    info = dicominfo(strcat(pathName,fileNames{i}));
    study = info.StudyInstanceUID;
    series = info.SeriesInstanceUID;
  catch
    errordlg(sprintf('File (%s) is not in DICOM format.',fileNames{i}),...
             'Invalid File', 'modal');
    return;
  end
            %load all of the images    
  n = size(fileNames,2);
  images = cell(0);
  dcmInfo = cell(0);
  for i=1:n
    try
      info = dicominfo(strcat(pathName,fileNames{i}));
                 %all slices must come from same study and series (same
                 %acquisition)
      if(~strcmp(study,info.StudyInstanceUID) ||...
         ~strcmp(series,info.SeriesInstanceUID))
        errordlg(sprintf('File (%s) and (%s) are not from same study and series.', fileNames(1), fileNames(i)),... 
                 'Invalid File Selection', 'modal');
        return;       
      end
      images{i} = dicomread(info);
      dcmInfo{i} = info;
      zCoordinates(i) = info.ImagePositionPatient(3);
    catch
      errordlg(sprintf('File (%s) is not in DICOM format.',fileNames{i}),...
               'Invalid File', 'modal');
      return;
    end
  end
         %I assume the z coordinate is the direction along which the slices
         %were acquired - assuming transaxial slices which is what most
         %scans will consist of
  [sortedZCoordinates, indexes] = sort(zCoordinates);
  handles.images = struct('pixelData', images(indexes),...
                          'dcmInfo',dcmInfo(indexes)); 
  handles.fileNames = {fileNames{indexes}};                          
           %set the image to display
  handles.currentDisplayImageNumber = 1;
         %remove all data estimated using previous data set and initialize
         %the GUI with the updated data
  clearData(handles);
  initializeGUIAfterLoadingImages(guidata(gcbo));
  set(handles.figure1,'Pointer','arrow');
% --------------------------------------------------------------------
%
%Initialize the GUI after loading the first frame from the cine loop:
%1. Make all controls visible and active.
%2. Make all menu items active.
%3. Display one of the loaded slices.
%
function initializeGUIAfterLoadingImages(handles)

                %initial window value
  n = size(handles.images,2);
  minValue = handles.images(1).pixelData(1);
  maxValue = minValue;
  for i=1:n
    minValue = min([handles.images(i).pixelData(:); minValue]);
    maxValue = max([handles.images(i).pixelData(:); maxValue]);
  end
  handles.minIntensity = minValue;              
  handles.maxIntensity = maxValue;              
  set(handles.imageAxes,'CLim', [minValue, maxValue] );   

           %populate the listbox with the file names, enable multi-select
           %(Max-Min>1) and set selection to current slice
  fileNames = handles.fileNames;
  fileNames{handles.currentDisplayImageNumber} = sprintf('<html><font color="red">%s</font></html>',fileNames{handles.currentDisplayImageNumber});
  set(handles.fileNamesListbox, 'String', fileNames);
  set(handles.fileNamesListbox, 'Max', 3, 'Min', 1);
  set(handles.fileNamesListbox, 'Value', handles.currentDisplayImageNumber); 
  set(handles.fileNamesListbox, 'Visible', 'on');
  
    %initialize the slider for browsing the image stack
  numberOfSlices = size(handles.images,2);
  set(handles.imageSlider, 'Min', 1);
  set(handles.imageSlider, 'Max', numberOfSlices);
  set(handles.imageSlider, 'SliderStep', [1/double(numberOfSlices-1),10/double(numberOfSlices-1)]);
  set(handles.imageSlider, 'Visible', 'on');
           %I flip the slider location so that it fits with the list
  set(handles.imageSlider, 'Value', numberOfSlices + 1 - handles.currentDisplayImageNumber);
    
             %initialize the viewing behaviour controls
  set(handles.viewingUIPanel, 'Visible', 'on');
  set(handles.zoomToolButton, 'Visible', 'on');
  set(handles.panToolButton, 'Visible', 'on');
  set(handles.windowLevelButton, 'Visible', 'on');
  set(handles.resetButton, 'Visible', 'on');
  set(handles.queryUIPanel, 'Visible', 'on');
  set(handles.pixelValueButton, 'Visible', 'on');
  set(handles.pixelValueText, 'Visible', 'on');
  
  
  set(handles.saveFiducialDataMenuItem, 'Enable', 'on');
  set(handles.loadFiducialDataMenuItem, 'Enable', 'on');
  set(handles.saveCurrentFigureMenuItem, 'Enable', 'on');

  set(handles.editMenuItem, 'Enable', 'on');  
      
              %initialize the thresholdSelectionDialogGUI    
  thresholdSelectionDialogHandles = guidata(handles.thresholdSelectionDialog);
  set(thresholdSelectionDialogHandles.thresholdSelectionSlider, 'Min', minValue);
  set(thresholdSelectionDialogHandles.thresholdSelectionSlider, 'Max', maxValue);
  set(thresholdSelectionDialogHandles.thresholdSelectionSlider, 'Value', round((minValue+maxValue)/2.0));
  set(thresholdSelectionDialogHandles.thresholdSelectionSlider, 'SliderStep', [1/double(maxValue-minValue),10/double(maxValue-minValue)]);
  set(thresholdSelectionDialogHandles.thresholdValueText, 'String', sprintf('%d',round((minValue+maxValue)/2.0)));

  guidata(gcbo, handles);
        %draw the initial frame   
  displayData(guidata(gcbo));
  
         %select the current axis and scale it to fit the image, this is 
         %done here once as all images in the serires have the same size
  axes(handles.imageAxes);
  axis image;

% --------------------------------------------------------------------
%
% Clear all the data, the 3D fiducial data 
% (allFiducialParameters).
%
function clearData(handles)
handles.allFiducialParameters = cell(0);
guidata(gcbo, handles);

% --------------------------------------------------------------------
function saveFiducialDataMenuItem_Callback(hObject, eventdata, handles)
              %open the file dialog and get the file name to which we need
               %to save the data. if an existing file is selected the file
               %dialog automatically confirms that it should be overwritten
  fileFilterSpecification = {'*.txt','Text file (*.txt)';...
                             '*.*','All files (*.*)'};
  fileDialogTitle = 'Save File Name';  
  [fileName, pathName] = uiputfile(fileFilterSpecification,...
                                   fileDialogTitle);
             %user chose a file 
   if fileName~=0                                  
         %save to the specified file  
     try
           %only saving the fiducial coordinates and losing the radius
           %which we aren't interested in
       n=size(handles.allFiducialParameters, 2);
       fiducialCoordinates = [];
       for i=1:n
         fiducialCoordinates = [fiducialCoordinates, handles.allFiducialParameters{i}(1:3)];
       end
       save(strcat(pathName,fileName), 'fiducialCoordinates', '-ASCII', '-DOUBLE','-TABS');
       handles.fiducialParametersSaved = 1;
       guidata(gcbo, handles);
     catch
       errordlg(lasterr(), 'Failed saving file', 'modal');
     end
   end
% --------------------------------------------------------------------
function saveCurrentFigureMenuItem_Callback(hObject, eventdata, handles)
              %open the file dialog and get the file name prefix
              %if any of the files exist ask for confirmation
  fileFilterSpecification = {'*.eps','Encapsulated Postscript (*.eps)';...
                             '*.emf','Enhanced Metafile (*.emf)';...
                             '*.fig','Matlab figure file (*.fig)';...
                             '*.*','All files (*.*)'};
  fileDialogTitle = 'Save File Name';  
  [fileName, pathName, filterIndex] = uiputfile(fileFilterSpecification,...
                                                fileDialogTitle);                                                                      
                                                                   
           %user chose a file 
  if fileName~=0
    indexes = strfind(fileName, '.');
    if size(indexes,2) == 0
      fileNamePrefix = fileName;
    else
      fileNamePrefix = fileName(1:indexes(end)-1);
    end            %save in all formats
    if filterIndex == 4
      savePlot(strcat(pathName, fileNamePrefix), handles.imageAxes);
    else        %save in specific format
      savePlot(strcat(pathName, fileNamePrefix),... 
               handles.imageAxes,... 
               fileFilterSpecification{filterIndex}(3:end));
    end
  end
% --------------------------------------------------------------------

function editMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to editMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function markROIMenuItem_Callback(hObject, eventdata, handles)
  
         %stop the zooming and panning behaviour if enabled
  if handles.zoomOn
    zoom(handles.figure1,'off');
  end
  if handles.panOn
    pan(handles.figure1,'off');
  end
   
  handles.currentROIImageIndexes = get(handles.fileNamesListbox, 'Value');
  
  ok = ~waitforbuttonpress();    
  if ok
    point1 = get(handles.imageAxes,'CurrentPoint');    
    finalRect = rbbox;                   
    point2 = get(handles.imageAxes,'CurrentPoint');    
               % extract x and y
    point1 = point1(1,1:2);              
    point2 = point2(1,1:2);
    minCoords = min(point1, point2);
    maxCoords = max(point1, point2);
              %need to flip for comparison as minCoords,maxCoords are
              %[x,y] and image size is given as [y,x]
    imageSizes = fliplr(size(handles.images(handles.currentDisplayImageNumber).pixelData));
            %limit the coordinates to be inside the image and the ROI must
            %be a valid rectangle, not one in which one or both sides have
            %dimension zero
    if all(maxCoords<=imageSizes) && all(maxCoords>=[1 1]) &&... 
       all(minCoords<=imageSizes) && all(minCoords>=[1 1]) &&...
       all(minCoords ~=maxCoords)
      handles.currentROIXYBounds = [minCoords;maxCoords];
         %save the data and display
      guidata(gcbo, handles);     
      displayData(guidata(gcbo));
    end
  end
  
         %restart the zooming and panning behaviour if enabled
  if handles.zoomOn
    zoom(handles.figure1,'on');
  end
  if handles.panOn
    pan(handles.figure1,'on');
  end

% --------------------------------------------------------------------
function edgeBasedFiducialLocalizationMenuItem_Callback(hObject, eventdata, handles)
  n = size(handles.currentROIImageIndexes,2);
  if n==0
    warndlg('ROI not marked, please mark ROI.', 'Missing ROI');
    return;
  end  
               %get the edge points found in the ROI, in a slice by slice
               %manner. ideally this should be done in 3D and not as done
               %here. unfortunatly matlab's image processing tools are
               %built for 2D isotropic data.
  edgePoints = [];
  for i=1:n
    edgePoints = [edgePoints, getEdges3D(handles.images(handles.currentROIImageIndexes(i)).pixelData,...
                                         handles.images(handles.currentROIImageIndexes(i)).dcmInfo,...
                                         handles.currentROIXYBounds(1,:), handles.currentROIXYBounds(2,:),...
                                         handles.EdgeBasedLocalization.cannyStd,... 
                                         handles.EdgeBasedLocalization.cannyLowThreshold,... 
                                         handles.EdgeBasedLocalization.cannyHighThreshold)];
  end  
           %clear the ROI
  handles.currentROIImageIndexes = [];
  handles.currentROIXYBounds = [];
  
  [sphereParameters, sphereConsensusSetIndexes] = ransacSphereConstrainedRadius(edgePoints,... 
                                                                                handles.EdgeBasedLocalization.expectedRadiusRange,...
                                                                                handles.EdgeBasedLocalization.agreementTolerance);
            %localization failed
  if isempty(sphereParameters)
    warndlg('Failed localizing fiducial in given ROI.', 'Failed Localization');
    return;
  end
        %localization succeeded
  handles.allFiducialParameters{end+1} = sphereParameters;
    handles.fiducialParametersSaved = 0;
       %save the data and display
  guidata(gcbo, handles);     
  displayData(guidata(gcbo));
% --------------------------------------------------------------------
function helpContentsMenuItem_Callback(hObject, eventdata, handles)

try
  fileName='help.txt';
  str = textread(fileName,'%s','whitespace', '', 'delimiter','\n');

   %create a figure with the title 'Help', remove the standard 'Figure n:'
   %and no menu bar
  screenSize = get( 0, 'ScreenSize' );
  h = figure('Name', 'Help',...
             'NumberTitle', 'off',...
             'MenuBar', 'none',...
             'Position', [screenSize(3)/2.0,screenSize(4)/2.0,700,300],...
             'Color', [0.8,0.8,0.8]);
         
    %add a 100 line edit control to the figure and display the text
  uicontrol('Parent',h,...
            'Units','normalized',...
            'hor', 'left',...
            'Position',[0.1,0.1,0.8,0.8],...
            'Style','edit',...
            'Max',2,...
            'Enable','inactive',...
            'BackgroundColor', [0.8,0.8,0.8],...
            'String', str);
catch
  errordlg(sprintf('Help file (%s) not found.',fileName),...
           'Missing help file', 'modal');
end


% --------------------------------------------------------------------
function helpMenuItem_Callback(hObject, eventdata, handles)
%nothing to do when opening the help menu


% --------------------------------------------------------------------
function aboutMenuItem_Callback(hObject, eventdata, handles)
str{1} = 'Software implementation of the work described in:';
str{2}=  '"Evaluation of Spherical Fiducial Localization in C-arm';
str{2} = strcat(str{2},' Cone-Beam CT using Patient Data", Z. Yaniv,');
str{2} = strcat(str{2},' Med. Phys., 37(10): 5298-5305, 2010.');


  %create a figure with the title 'Help', remove the standard 'Figure n:'
  %and no menu bar
screenSize = get( 0, 'ScreenSize' ); 
h = figure('Name', 'About',...
           'NumberTitle','off',...
           'MenuBar','none',... 
           'Position', [screenSize(3)/2.0,screenSize(4)/2.0,450,50],...
           'Color', [0.8,0.8,0.8]);
 %add a 100 line edit control to the figure and display the text
uicontrol('Parent',h,...
          'Units','normalized',...
          'hor', 'left',...
          'Position',[0.1,0.1,0.8,0.8],...
          'Style','text',...
          'Max',2,...          
          'String', str,...
          'BackgroundColor', [0.8,0.8,0.8]);


% --------------------------------------------------------------------
function licenseMenuItem_Callback(hObject, eventdata, handles)
try 
  fileName='license.txt';
  str = textread(fileName,'%s','whitespace', '', 'delimiter','\n');

   %create a figure with the title 'Help', remove the standard 'Figure n:'
   %and no menu bar
  screenSize = get( 0, 'ScreenSize' ); 
  h = figure('Name', 'License',...
             'NumberTitle', 'off',...
             'MenuBar', 'none',...
             'Position', [screenSize(3)/2.0,screenSize(4)/2.0,700,300],...
             'Color', [0.8,0.8,0.8]);
         
    %add a 100 line edit control to the figure and display the text
  uicontrol('Parent',h,...
            'Units','normalized',...
            'hor', 'left',...
            'Position',[0.1,0.1,0.8,0.8],...
            'Style','edit',...
            'Max',2,...
            'Enable','inactive',...
            'BackgroundColor', [0.8,0.8,0.8],...
            'String', str);
catch
  errordlg(sprintf('License file (%s) not found.',fileName),...
           'Missing license file', 'modal');
end
% --------------------------------------------------------------------
function loadFiducialDataMenuItem_Callback(hObject, eventdata, handles)
               %open the file dialog and get the file name we want to read
  fileFilterSpecification = {'*.txt','Text file (*.txt)';...
                             '*.*','All files (*.*)'};
   fileDialogTitle = 'Fiducial Data File Name';  
   [fileName, pathName] = uigetfile(fileFilterSpecification,...
                                    fileDialogTitle,...
                                    'MultiSelect','off');
             %user chose a file 
   if fileName~=0 
      try 
        fiducialData = load(strcat(pathName,fileName));
        if size(fiducialData,1) == 3
            clearData(handles);
           n=size(fiducialData,2);
           for i=1:n
             handles.allFiducialParameters{i} = fiducialData(:,i);
           end
            guidata(gcbo, handles);
            displayData(guidata(gcbo));
        else
            errordlg(message, 'Error in fiducial data', 'modal');
        end
      catch
        errordlg(lasterr(), 'Failed reading fiducial data file', 'modal');
      end
   end   

% --------------------------------------------------------------------

function quitMenuItem_Callback(hObject, eventdata, handles)

quit(handles);
% --------------------------------------------------------------------

function closeGUI(src, evnt)
 
quit(guidata(gcbo));
% --------------------------------------------------------------------  

function quit(handles)

  if ~handles.fiducialParametersSaved &... 
     ~isempty(handles.allFiducialParameters)    
    selectionStr = questdlg('Exit without saving?',...
                            'Discard Data Confirmation','Yes','No','No');
    if strcmp(selectionStr,'No')
      return;      
    end
  end
       %use delete instead of close as otherwise the closeGUI callback
       %function will be called recursively (the 'close' function generates the
       %close event which triggers the closeGUI function which would have
       %called close...).
  delete(handles.thresholdSelectionDialog);   
  delete(handles.figure1);
% --------------------------------------------------------------------  
function displayData(handles)

       %select the axes on which to draw
  axes(handles.imageAxes);
       %clear the axes, otherwise the data is added to the axes object
       %on top of the previous data, the program keeps allocating more and
       %more memory which we don't need
  cla(handles.imageAxes);
      %draw the image with gray level scaling and remove the axes
      %(imagesc makes the axes visible so I need to remove it after 
      %every call to imagesc)               
  imagesc(handles.images(handles.currentDisplayImageNumber).pixelData,... 
          get(handles.imageAxes,'CLim'));
  set(handles.imageAxes, 'Visible', 'off');
  hold on;
             %draw the ROI rectangle on the image, if it is part of the ROI box
  if find(handles.currentROIImageIndexes==handles.currentDisplayImageNumber)
            %draw only if the threshold selection dialog is visible
    if strcmp(get(handles.thresholdSelectionDialog,'Visible'),'on')                
           %inside the rectangle draw the pixels that are above the
           %threshold using alpha blending
      startRow = round(handles.currentROIXYBounds(1,2));
      endRow = round(handles.currentROIXYBounds(2,2));
      startColumn = round(handles.currentROIXYBounds(1,1));
      endColumn = round(handles.currentROIXYBounds(2,1));
      subImage = handles.images(handles.currentDisplayImageNumber).pixelData(startRow:endRow, startColumn:endColumn);
      [rows,cols] = find(subImage>handles.threshold);
                 %only do this operation if there are pixels above the
                 %threshold, do the alpha blending ourselves                            
      if ~isempty(rows)
        rows = rows+startRow-1;
        cols = cols+startColumn-1;
        gray = mat2gray(handles.images(handles.currentDisplayImageNumber).pixelData);
        thresholdingImageResult(:,:,1) = gray;
        thresholdingImageResult(:,:,2) = thresholdingImageResult(:,:,1);
        thresholdingImageResult(:,:,3) = thresholdingImageResult(:,:,1);
        for i=1:size(rows,1)
          thresholdingImageResult(rows(i), cols(i),:) = squeeze(0.5*thresholdingImageResult(rows(i), cols(i),:)) + 0.5*handles.Display.aboveThresholdOverlayColor';
        end
        imagesc(thresholdingImageResult);
        set(handles.imageAxes, 'Visible', 'off');

%              %BUG, alpha blending using the matlab function results in a
%              %     bug in the program:
%              %for some reason when this line is here if I scroll
%              %through the selected ROI after the last image the rest of
%              %the image stack is scrolled through too even if the slider is
%              %not pressed??     
%
%      thresholdingResultImage = zeros(size(handles.images(handles.currentDisplayImageNumber).pixelData,1),...
%                                      size(handles.images(handles.currentDisplayImageNumber).pixelData,2),...
%                                      3);
%                                      
%         for i=1:size(rows,1)
%           thresholdingResultImage(rows(i), cols(i),:) = ABOVE_THRESHOLD_COLOR;
%         end      
%         thresholdImageHandle = imagesc(thresholdingResultImage);
%
%         alphaMap = zeros(size(handles.images(handles.currentDisplayImageNumber).pixelData));
%         indexes = sub2ind(size(handles.images(handles.currentDisplayImageNumber).pixelData), rows, cols);
%         alphaMap(indexes) = 0.5;
%         alpha(thresholdImageHandle, alphaMap);
      end   
    end
    rectangle('Position', [handles.currentROIXYBounds(1,:), handles.currentROIXYBounds(2,:) - handles.currentROIXYBounds(1,:)],...
              'LineStyle', handles.Display.roiLineStyle, 'EdgeColor', handles.Display.roiLineColor);
  end
                 %draw all the fiducials  
  n = size(handles.allFiducialParameters, 2);
  for i=1:n
    fiducialParameters = handles.allFiducialParameters{i};
          %use default radius for drawing if localization only provides the
          %fiducial's center
    if size(fiducialParameters, 1) == 3
      fiducialParameters(4) = handles.Display.sphereRadius;
    end
    colorTableIndex = mod(i, size(handles.Display.fiducialColorTable,2));
    if colorTableIndex == 0         
      colorTableIndex = size(handles.Display.fiducialColorTable,2);
    end
                     %draw the fiducial
    drawSpherePlaneIntersection(handles.images(handles.currentDisplayImageNumber).dcmInfo,...
                                fiducialParameters,...
                                handles.Display.fiducialLineWidth,...
                                handles.Display.fiducialLineStyle,...
                                handles.Display.fiducialColorTable{colorTableIndex});      
  end
  
  
% --------------------------------------------------------------------
function drawSpherePlaneIntersection(dcmInfo, sphereParameters,...
                                     lineWidth,...
                                     lineStyle,...
                                     lineColor)

  %get the sphere in the slice's local coordinate system, the slice plane
  %becomes the xy plane (z==0)
  R = [dcmInfo.ImageOrientationPatient(1:3),...
       dcmInfo.ImageOrientationPatient(4:6),...
       cross(dcmInfo.ImageOrientationPatient(1:3),...
             dcmInfo.ImageOrientationPatient(4:6))];
           
  T = [[R', -R'*dcmInfo.ImagePositionPatient];[0, 0, 0, 1]];
  sphereCenterInImageCoordinateSystem = T*[sphereParameters(1:3);1];
  
            %check if the sphere actualy intersects the plane
  if abs(sphereCenterInImageCoordinateSystem(3)) > sphereParameters(4)
    return;
  end
       %the sphere intersects the image plane, draw it
  mm2pix = 1/dcmInfo.PixelSpacing(1);
     %add 1, pixel locations in matlab start at 1
  cx = sphereCenterInImageCoordinateSystem(1)*mm2pix;
  cx = cx+1;
  cy = sphereCenterInImageCoordinateSystem(2)*mm2pix;
  cy = cy+1;
  r =  sqrt(sphereParameters(4)^2 - sphereCenterInImageCoordinateSystem(3)^2)*mm2pix;
  drawCircle(cx, cy, r, gca, lineStyle, lineColor, lineWidth);
  
% --------------------------------------------------------------------
function pixelValueButton_Callback(hObject, eventdata, handles)
  [x,y] = ginput(1);
  
  imageSizes = fliplr(size(handles.images(handles.currentDisplayImageNumber).pixelData));
  if all([x,y]<=imageSizes) && all([x,y]>=[1 1]) 
    set(handles.pixelValueText,'String', sprintf('%d', handles.images(handles.currentDisplayImageNumber).pixelData(round(y),round(x))));
  end
  
% --------------------------------------------------------------------
function manualThresholdFiducialLocalizationMenuItem_Callback(hObject, eventdata, handles)
                %ROI must be marked before we start
  n = size(handles.currentROIImageIndexes,2);
  if n==0
    warndlg('ROI not marked, please mark ROI.', 'Missing ROI');
    return;
  end  
             %get the dialog handle and display it
  thresholdSelectionDialogHandles = guidata(handles.thresholdSelectionDialog);  
  set(thresholdSelectionDialogHandles.figure1, 'Visible', 'on');
             %update the current threshold to reflect the dialog's value and redisplay   
  handles.threshold = round(get(thresholdSelectionDialogHandles.thresholdSelectionSlider, 'Value'));
       %save the data update the display and set the focus back onto the
       %dialog
  guidata(gcbo, handles);     
  displayData(guidata(gcbo));
  figure(thresholdSelectionDialogHandles.figure1);
  
% --------------------------------------------------------------------
%
% Compute the intensity weighted center of the spherical fiducial. This
% approach assumes that the probability for a voxel to be part of the
% fiducial is directly dependent upon its intensity value (higher intensity
% means higher probability). 
% The implementation is not the standard flood fill based approach, but
% yields the same result. The choice of this specific approach is due to ease of
% implementation in matlab:
%
% 1. User specifices volume of interest (ROI, Region==Volume).
% 2. User interactively selects threshold for that ROI.
% 3. User selects a point inside the fiducial.
% 4. We threshold the ROI resulting in a binary volume.
% 5. We then create a connected component label map from the binary volume using the
%    specific value of handles.IntensityBasedLocalization.connectivity (faces=6, faces+edges=18, faces+edges+vertices=26).
% 6. Select the connected component which contains the user selected point (step 3).
% 7. Compute the intensity weighted centroid of the connected component.
%
function intensityWeightedCentroidFiducialLocalization(handles)
    
  startRow = round(handles.currentROIXYBounds(1,2));
  endRow = round(handles.currentROIXYBounds(2,2));
  startColumn = round(handles.currentROIXYBounds(1,1));
  endColumn = round(handles.currentROIXYBounds(2,1));
  
        %force point selection inside the ROI bounds and at a location
        %above the selected threshold
  [x,y] = ginput(1);
  if x<startColumn || x>endColumn+1 ||...
     y<startRow || y>endRow+1 ||...
     handles.currentDisplayImageNumber<handles.currentROIImageIndexes(1)|| handles.currentDisplayImageNumber>handles.currentROIImageIndexes(end)||...
     handles.images(handles.currentDisplayImageNumber).pixelData(round(y),round(x))<=handles.threshold
    errordlg('Selected point must be inside ROI and above your threshold selection.',...
             'Invalid Input', 'modal');
    return;
  end
  
  sumWeights = 0;
  weightedCentroid = [0; 0; 0];
  n = size(handles.currentROIImageIndexes,2); 
  bw = zeros(endRow-startRow+1, endColumn-startColumn+1,n); 
  for i=1:n    
    subImage = handles.images(handles.currentROIImageIndexes(i)).pixelData(startRow:endRow, startColumn:endColumn);
    [rows,cols] = find(subImage>handles.threshold);
    bw(rows,cols,i) = 1;
  end
        %label the connected components and retrieve the one the user
        %chose
  labelMap = bwlabeln(bw, handles.IntensityBasedLocalization.connectivity);
  selectedLabel = labelMap(round(y) - startRow+1,... 
                           round(x) - startColumn+1,...
                           handles.currentDisplayImageNumber - handles.currentROIImageIndexes(1)+1);
  for i=1:n    
    [rows,cols] = find(labelMap(:,:,i) == selectedLabel);                                               
                 %only do this operation if there are pixels above the
                 %threshold
    if ~isempty(rows)
            %use the row/col indexes in the original image
      rows = rows+startRow-1;
      cols = cols+startColumn-1;
      indexes = sub2ind(size(handles.images(handles.currentROIImageIndexes(i)).pixelData), rows, cols);
      intensities = double((handles.images(handles.currentROIImageIndexes(i)).pixelData(indexes))');
             %get the 3D locations of the pixels that are above the user 
             %specified threshold  
      currentDCMInfo = handles.images(handles.currentROIImageIndexes(i)).dcmInfo;
      pixel2Volume = [currentDCMInfo.ImageOrientationPatient(1:3)*currentDCMInfo.PixelSpacing(1),...
                      currentDCMInfo.ImageOrientationPatient(4:6)*currentDCMInfo.PixelSpacing(2),...
                      cross(currentDCMInfo.ImageOrientationPatient(1:3),...
                            currentDCMInfo.ImageOrientationPatient(4:6)),...
                      currentDCMInfo.ImagePositionPatient];
      pixel2Volume = [pixel2Volume;[0 0 0 1]];
                    %get the pixel locations in the 3D coordinate system,
                    %need to subtract 1 from rows/cols as matlab starts
                    %indexes at 1 and the origin is zero
      points3D = pixel2Volume * [cols'-1; rows'-1; zeros(1,size(cols,1)); ones(1,size(cols,1))];
      weightedCentroid = weightedCentroid + sum(intensities(ones(3,1),:).*points3D(1:3,:),2);
      sumWeights = sumWeights + sum(intensities);
    end
  end
             %clear the ROI
  handles.currentROIImageIndexes = [];
  handles.currentROIXYBounds = [];

              %add the fiducial to our data set  
  handles.allFiducialParameters{end+1} = weightedCentroid/sumWeights;
  handles.fiducialParametersSaved = 0;
       %save the data and redisplay
  guidata(handles.figure1, handles);
  displayData(handles);
  
% --------------------------------------------------------------------
function removeLastMenuItem_Callback(hObject, eventdata, handles)
if size(handles.allFiducialParameters,2)<=1
  handles.allFiducialParameters = cell(0);
  handles.fiducialParametersSaved = 1;
else 
  handles.allFiducialParameters = {handles.allFiducialParameters{1:end-1}};
end
        %save the data and redisplay
guidata(handles.figure1, handles);
displayData(handles);


